tazpkg annotate modules/get @ rev 889

Module 'recharge': don't link files when using local repo
author Aleksej Bobylev <al.bobylev@gmail.com>
date Wed Dec 16 12:01:42 2015 +0200 (2015-12-16)
parents 1362693564d1
children 3af642cd5e69
rev   line source
al@844 1 #!/bin/sh
al@844 2 # TazPkg - Tiny autonomous zone packages manager, hg.slitaz.org/tazpkg
al@844 3 # get - TazPkg module
al@844 4 # Get package to the cache directory
al@844 5
al@844 6
al@844 7 # 1. "Plain packages" - compiled and packed on cook.slitaz.org using receipts.
al@844 8 #
al@844 9 # Recently added other type of packages: packages that can't be compiled due to the closed sources
al@844 10 # or due to the giant size of that sources. In this case special script: a) downloads package
al@844 11 # compiled for other Linux from official web site, b) converts this package to the TazPkg format,
al@844 12 # c) installs this package as "plain" package.
al@844 13 #
al@844 14 # 2. "Get-packages" - package contains only one special script for downloading/converting.
al@844 15 # Sometimes get-package can get some specified version of the package, sometimes - different
al@844 16 # (latest) version.
al@844 17 #
al@844 18 # Packages 1. and 2. can be found in the wok repository: http://hg.slitaz.org/wok/
al@844 19 #
al@844 20 # 3. "Extra" get-scripts. Next addition - only script, without packaging.
al@844 21 # Extra get-scripts repository: http://hg.slitaz.org/get-scripts/
al@844 22 # Extra get-scripts mirror: http://mirror.slitaz.org/packages/get/
al@844 23 #
al@844 24 # 4. Converted "extra" packages. Next addition - some packages like LibreOffice / OpenOffice are
al@844 25 # big to compile them like _1. "Plain packages"_ as well as big to convert them on the user side
al@844 26 # (you need a lot of time, CPU, and RAM) and sometimes it is unable on the weak user machines.
al@844 27 # So, some selected and free packages are converted on the SliTaz server side, packaged and
al@844 28 # are ready to download by any user: http://mirror.slitaz.org/packages/extra/
al@844 29 #
al@844 30 #
al@844 31 # Algorithm to get package:
al@844 32 # - search package in question in the mirrored packages list, download if exists;
al@844 33 # - search "get-package" in the mirrored packages list, download if exists;
al@844 34 # - search package in the "extra" get-scripts list, download if exists and run it, get the package.
al@844 35 #
al@844 36 # Note, here doubling. Imagine, you may wanted "palemoon" package.
al@844 37 # 1. No "plain package";
al@844 38 # 2. Existing "get-palemoon" package;
al@844 39 # 3. Existing "palemoon" extra get-script;
al@844 40 # 4. Existing "palemoon" extra converted package.
al@844 41 # User will get 2. He can specify "--extra" option to get 3.
al@844 42 # FIXME: do something with doubling.
al@844 43
al@844 44
al@844 45
al@844 46
al@844 47 # Connect function libraries
al@844 48 . /lib/libtaz.sh
al@844 49 . /usr/lib/slitaz/libpkg.sh
al@844 50
al@844 51 # Get TazPkg working environment
al@844 52 . @@MODULES@@/getenv
al@844 53
al@844 54 . @@MODULES@@/find-depends
al@844 55
al@844 56
al@844 57
al@844 58
al@844 59 # Get cache directory path
al@844 60
al@844 61 get_cache_path() {
al@844 62 # input: $1 = DB folder such as "$PKGS_DB" or "$PKGS_DB/undigest/*"
al@844 63 # $2 (optional): 'extra' for cache for extra-package scripts
al@844 64 # output: path to cache directory
al@844 65
al@844 66 local cache_dir
al@844 67
al@844 68 if [ "$2" == 'extra' ]; then
al@844 69 cache_dir="$SAVE_CACHE_DIR/extra/packages"
al@844 70 elif [ "$1" == "$PKGS_DB" ]; then
al@844 71 # Main repository
al@844 72 cache_dir="$SAVE_CACHE_DIR/$SLITAZ_RELEASE/packages"
al@844 73 else
al@844 74 # Undigest repository
al@844 75 cache_dir="$SAVE_CACHE_DIR/${1##*/}/packages"
al@844 76 fi
al@844 77
al@844 78 # Make cache directory if absent
al@844 79 mkdir -p "$cache_dir"
al@844 80 chmod a+w "$cache_dir"
al@844 81
al@844 82 echo "$cache_dir"
al@844 83 }
al@844 84
al@844 85
al@844 86 # Download a file from mirror
al@844 87
al@844 88 download_from() {
al@844 89 # input: "<mirror_url>" "<package_name>-<version>.tazpkg"
al@844 90
al@844 91 debug "\ndownload_from('$1', '$2')"
al@844 92
al@844 93 case "$1" in
al@844 94 # Mirror URL can have a trailing slash or not.
al@844 95 http://* | https://* | ftp://*)
al@862 96 debug " wget -c -T 30 -U $UA ${1%/}/$2"
al@877 97 q=''; [ -n "$quiet" ] && q='-q'
al@864 98 # Display abridged wget status (skip info about connections)
al@877 99 wget -c $q -T 30 -U $UA ${1%/}/$2 2>&1 | awk 'BEGIN{RS="\r"}$0~"%"{printf "%s\r",$0}' >&2
al@844 100 ;;
al@844 101 *)
al@863 102 debug " cp ${1%/}/$2 ."
al@863 103 cp ${1%/}/$2 .;;
al@844 104 esac
al@844 105 }
al@844 106
al@844 107
al@844 108 # This function may be called by a get script.
al@844 109
al@844 110 abort_package() {
al@844 111 cd "$CUR_DIR"
al@844 112 rm -rf "$tmp_dir"
al@844 113 echo "${1:-Abort $PACKAGE.}"
al@844 114 exit 1
al@844 115 }
al@844 116
al@844 117
al@844 118 # Get extra-package file to the cache
al@844 119
al@844 120 get_pkg_extra() {
al@844 121 # input: $1 extra-package name (like 'dropbox')
al@844 122 # $2 (internal): empty or 'redo' (when recursive calling)
al@844 123 # action: download stuff and make package
al@844 124 # output: full path to created package
al@844 125
al@844 126 debug "\nget_pkg_extra('$1', '$2')"
al@844 127
al@844 128 local mirror extra_cache converted tmp_dir script
al@844 129
al@844 130 # Check extra.list
al@844 131 if [ ! -s "$PKGS_DB/extra.list" ]; then
al@844 132 # Empty extra.list
al@844 133 if [ "$2" != 'redo' ]; then
al@844 134 tazpkg recharge >&2
al@844 135 get_pkg_extra "$1" 'redo'; exit 0
al@844 136 else
al@844 137 # Give up
al@844 138 _ 'File "%s" empty.' 'extra.list' >&2
al@844 139 die 'Unable to find package "%s" in the extra packages list.' "$(boldify $1)"
al@844 140 fi
al@844 141 fi
al@844 142
al@844 143 # Extra.list exists and not empty
al@844 144 if ! grep -q "^$1|" "$PKGS_DB/extra.list"; then
al@844 145 die 'Unable to find package "%s" in the extra packages list.' "$(boldify $1)"
al@844 146 fi
al@844 147
al@844 148 # Extra-package found in extra.list
al@844 149
al@844 150 if [ -z "$nocache" ]; then
al@844 151 # Go to cache for "get-install" command; don't move for "get" command
al@844 152 extra_cache="$(get_cache_path "$PKGS_DB" 'extra')"
al@844 153 debug "cd '$extra_cache'"
al@844 154 cd "$extra_cache"
al@844 155
al@844 156 # Extra-cache should contain packages DB files (packages.info, etc.)
al@844 157 # to list extra-packages contained in the extra-cache
al@844 158 [ ! -f 'packages.info' ] && tazpkg mkdb "$extra_cache" --root='' --forced >/dev/null
al@844 159
al@844 160 if [ -f 'packages.info' ]; then
al@844 161 awk -F$'\t' -vp="$1" '$1==p{exit 1}' packages.info
al@844 162 if [ "$?" -eq 1 ]; then
al@876 163 [ -z "$quiet" ] && _ 'Package "%s" already in the cache' "$1" >&2
al@844 164 echo -n "$(pwd)/"
al@844 165 awk -F$'\t' -vp="$1" '$1==p{printf "%s-%s.tazpkg\n", $1, $2; exit}' packages.info
al@844 166 exit 0
al@844 167 fi
al@844 168 fi
al@844 169 fi
al@844 170
al@844 171 mirror="$(cat "$PKGS_DB/mirror")"
al@844 172 debug "mirror='$mirror'"
al@844 173
al@844 174
al@844 175 # Try converted extra-packages first
al@844 176 # FIXME: Workaround to get packages filenames (even better to have names and versions separate)
al@846 177 converted="$(wget -O - http://mirror1.slitaz.org/packages/extra/ 2>/dev/null | \
al@844 178 tr \'\" $'\n' | grep "$1-.*\.tazpkg$" | sort -u)"
al@844 179 debug "converted='$converted'"
al@844 180 if [ -n "$converted" ]; then
al@844 181 case "$mirror" in
al@844 182 http://*|https://*|ftp://*)
al@844 183 # Default 'http://mirror.slitaz.org/packages/cooking/'
al@844 184 # -> 'http://mirror.slitaz.org/packages/extra/'
al@862 185 debug "wget -T 30 -U '$UA' '${mirror%packages/*}packages/extra/$converted'"
al@877 186 q=''; [ -n "$quiet" ] && q='-q'
al@877 187 wget $q -T 30 -U "$UA" "${mirror%packages/*}packages/extra/$converted" \
al@864 188 2>&1 | awk 'BEGIN{RS="\r"}$0~"%"{printf "%s\r",$0}' >&2;;
al@844 189 esac
al@844 190 if [ -f "$converted" ]; then
al@844 191 echo "$extra_cache/$converted"; exit 0
al@844 192 fi
al@844 193 fi
al@844 194
al@844 195
al@844 196 # Fails to download converted extra-package; now try to download and execute get-script
al@844 197 cd ..
al@844 198 case "$mirror" in
al@844 199 http://*|https://*|ftp://*)
al@844 200 # Default 'http://mirror.slitaz.org/packages/cooking/'
al@844 201 # -> 'http://mirror.slitaz.org/packages/get/'
al@862 202 debug "wget -T 30 -U '$UA' '${mirror%packages/*}packages/get/$1'"
al@877 203 q=''; [ -n "$quiet" ] && q='-q'
al@877 204 wget $q -T 30 -U "$UA" "${mirror%packages/*}packages/get/$1" \
al@864 205 2>&1 | awk 'BEGIN{RS="\r"}$0~"%"{printf "%s\r",$0}' >&2;;
al@844 206 esac
al@844 207
al@844 208 if [ ! -f "$1" ]; then
al@844 209 # TODO: extra package or extra package script? :) Too complicated...
al@844 210 die 'Unable to download extra package "%s".' "$(boldify $1)"
al@844 211 fi
al@844 212
al@844 213 # Extra-package script downloaded in the /var/cache/tazpkg/extra/
al@844 214
al@844 215 unset_receipt
al@844 216 PACKAGE="$1"
al@844 217 script="$(realpath $1)"
al@844 218 tmp_dir="$(mktemp -d)"; cd "$tmp_dir"
al@844 219 # Run script
al@844 220 set -e
al@844 221 . "$script"
al@844 222 set +e
al@844 223
al@844 224 if [ ! -d "$PACKAGE-$VERSION" ]; then
al@844 225 abort_package 'Could not download "%s" from "%s". Exiting.' "${TARBALL:-$PACKAGE}" "${WGET_URL:-$WEB_SITE}"
al@844 226 fi
al@844 227
al@844 228 if [ ! -s "$PACKAGE-$VERSION/receipt" ]; then
al@844 229 # Create receipt (if script not created it early) using variables from script
al@844 230 cat > "$PACKAGE-$VERSION/receipt" <<EOT
al@844 231 # SliTaz package receipt.
al@844 232
al@844 233 PACKAGE="$PACKAGE"
al@844 234 VERSION="${VERSION:-unknown}"
al@844 235 CATEGORY="${CATEGORY:-non-free}"
al@844 236 WEB_SITE="$WEB_SITE"
al@844 237 SHORT_DESC="${SHORT_DESC:-$PACKAGE}"
al@844 238 MAINTAINER="${MAINTAINER:-nobody@slitaz.org}"
al@844 239 LICENSE="$LICENSE"
al@844 240 TARBALL="$TARBALL"
al@844 241 WGET_URL="$WGET_URL"
al@844 242 CONFIG_FILES="$CONFIG_FILES"
al@844 243 SUGGESTED="$SUGGESTED"
al@844 244 PROVIDE="$PROVIDE"
al@844 245 DEPENDS="$DEPENDS"
al@844 246 HOST_ARCH="$HOST_ARCH"
al@844 247 TAGS="$TAGS"
al@844 248 EXTRA_SOURCE_FILES="$EXTRA_SOURCE_FILES"
al@844 249 EOT
al@844 250 fi
al@844 251
al@844 252 # Add dependencies which was found to already defined dependencies
al@844 253 DEPENDS="$(unset DEPENDS; . "$PACKAGE-$VERSION/receipt"; echo $DEPENDS)"
al@844 254 for i in $(find_depends "$PACKAGE-$VERSION/fs"); do
al@844 255 case " $DEPENDS " in
al@844 256 *\ $i\ *) continue;;
al@844 257 esac
al@844 258 sed -i "s/^DEPENDS=\"/&$i /" "$PACKAGE-$VERSION/receipt"
al@844 259 done
al@844 260
al@844 261 # Remove empty variables
al@844 262 sed -i '/=""$/d' "$PACKAGE-$VERSION/receipt"
al@844 263
al@844 264 tazpkg pack "$PACKAGE-$VERSION" gzip >&2
al@844 265
al@844 266 if [ -z "nocache" ]; then
al@844 267 # move package to the extra-cache for "get-install" command
al@844 268 mv -f "$tmp_dir/$PACKAGE-$VERSION.tazpkg" "$extra_cache"
al@844 269 # Re-make extra packages database
al@844 270 tazpkg mkdb "$extra_cache" --root='' --forced >/dev/null
al@844 271 else
al@844 272 # move package to directory where "tazpkg get" command invoked
al@844 273 mv -f "$tmp_dir/$PACKAGE-$VERSION.tazpkg" "$CUR_DIR"
al@844 274 fi
al@844 275
al@844 276 # Clean
al@844 277 rm -rf "$tmp_dir"
al@844 278
al@844 279 # Function output: path to package
al@844 280 echo "$CUR_DIR/$PACKAGE-$VERSION.tazpkg"
al@844 281 }
al@844 282
al@844 283
pascal@873 284 # return possible name for a virtual package name
pascal@873 285
pascal@873 286 virtual_pkg() {
pascal@873 287 # input: $1 virtual package name
pascal@873 288 # $2 repository db directory
al@876 289 # output: display possible package name
pascal@873 290
al@887 291 debug "\nvirtual_pkg('$1', '$2')"
pascal@873 292 local i
al@887 293 unset IFS
pascal@873 294 for i in $(grep -hs "^$1=" "$2/packages.equiv" | sed "s/^$1=//"); do
pascal@873 295 if echo $i | fgrep -q : ; then
pascal@873 296 # format 'alternative:newname'
pascal@873 297 # if alternative is installed then substitute newname
pascal@874 298 if [ -f $INSTALLED/${i%:*}/receipt ]; then
pascal@873 299 # substitute package dependency
pascal@873 300 echo ${i#*:}
pascal@873 301 return
pascal@873 302 fi
al@887 303 elif ! grep -q "^$1 " "$2/packages.info" || [ -f "$INSTALLED/$i/receipt" ]; then
pascal@873 304 # unconditional substitution
pascal@873 305 echo $i
pascal@873 306 return
pascal@873 307 fi
pascal@873 308 done
pascal@879 309 # the real package name
pascal@879 310 echo $1
pascal@873 311 }
pascal@873 312
al@887 313
al@844 314 # Download package file to the cache
al@844 315
al@844 316 get_pkg() {
al@844 317 # input: $1 package name either "name" or "name-version"
al@844 318 # $2 (internal): empty or 'redo' (when recursive calling)
al@844 319 # action: download package from mirror to the cache directory
al@844 320 # output: full path to the downloaded package
al@844 321
al@844 322 debug "\nget_pkg('$1', '$2')"
al@844 323 local repo line namever pkgsum
al@844 324
al@844 325 IFS=$'\n'
al@844 326 for rep in $PRIORITY; do
al@844 327 [ ! -f "$rep/packages.info" ] && continue
al@844 328 # If found, output string "<name>-<ver>:<sum>"
pascal@879 329 line=$(awk -F$'\t' -vpkg="$(virtual_pkg "$1" "$rep")" \
pascal@879 330 '$1==pkg || $1"-"$2==pkg {printf "%s-%s:%s", $1, $2, $9; exit}' "$rep/packages.info")
al@844 331 if [ -n "$line" ]; then
al@844 332 namever=${line%:*}; pkgsum=${line#*:}
al@844 333 break
al@844 334 fi
al@844 335 done
al@844 336 unset IFS
al@844 337
al@844 338 debug " rep='$rep'\n namever='$namever'\n pkgsum='$pkgsum'"
al@844 339
al@844 340 if [ -z "$line" ]; then
al@889 341 _ 'Unable to find package "%s" in the mirrored packages list.' "$1" >&2
al@844 342 # Retry with "get-package"; prevent looping with 'redo'
al@844 343 if [ "$2" != 'redo' ]; then
al@844 344 get_pkg "get-$1" 'redo'; exit 0
al@844 345 else
al@844 346 # Retry with extra-package
al@844 347 get_pkg_extra "${1#get-}"
al@844 348 exit 0
al@844 349 fi
al@844 350 fi
al@844 351
al@844 352 # We need package "$namever.tazpkg" from "$rep" with "$pkgsum"
al@844 353
al@844 354 if [ -z "$nocache" ]; then
al@844 355 # Go to cache for "get-install" command; don't move for "get" command
al@844 356 debug "cd '$(get_cache_path "$rep")'"
al@844 357 cd "$(get_cache_path "$rep")"
al@844 358 fi
al@844 359
al@844 360 # Check if package already downloaded
al@844 361 if [ -f "$namever.tazpkg" ]; then
al@876 362 [ -z "$nocache" -a -z "$quiet" ] && _ 'Package "%s" already in the cache' "$namever" >&2
al@844 363
al@844 364 # Check if downloading complete, resume it not complete
al@844 365 if ! tail -c 2k "$namever.tazpkg" | fgrep -q '00000000TRAILER'; then
al@876 366 [ -z "$quiet" ] && _ 'Continuing package "%s" download' "$namever" >&2
al@844 367 download_from "$(cat "$rep/mirror")" "$namever.tazpkg"
al@844 368 fi
al@844 369 else
al@844 370 # Package absent in the cache, "cold" downloading
al@844 371 download_from "$(cat "$rep/mirror")" "$namever.tazpkg"
al@844 372 fi
al@844 373
al@844 374 # Make sure we downloaded what we want with checksum
al@844 375
al@844 376 if [ "$($CHECKSUM "$namever.tazpkg" | cut -d' ' -f1)" != "$pkgsum" ]; then
al@845 377 _ 'Checksum error for "%s"' "$namever.tazpkg" >&2
al@844 378 rm "$namever.tazpkg"
al@844 379
al@844 380 # Recharge DBs and try again; prevent looping with 'redo'
al@844 381 if [ "$2" != 'redo' ]; then
al@844 382 tazpkg recharge >&2
al@844 383 get_pkg "$1" 'redo'; exit 0
al@844 384 else
al@844 385 # Give up
al@844 386 # TODO: try another mirror?
al@844 387 die 'Please wait until the mirror synchronization is complete and try again.'
al@844 388 fi
al@844 389 fi
al@844 390
al@844 391 # Output: path to downloaded package
al@844 392 printf '%s/%s.tazpkg\n' "$(pwd)" "$namever"
al@844 393 }
al@844 394
al@844 395
al@844 396
al@844 397
al@864 398 # Command 'get-install' calls 'get', then 'install' modules. Check package presence here, on the
al@864 399 # first stage, if '--forced' option not given
al@866 400 if [ "$tazpkg_command" == 'get-install' ]; then
al@866 401 if grep -qs "^$1$" "$BLOCKED"; then
al@866 402 _ 'Package "%s" blocked.' "$1" >&2
al@864 403 exit 1
al@864 404 fi
al@866 405
al@866 406 if [ -z "$forced" ]; then
al@866 407 awk -F$'\t' -vpv="$1" '$1==pv { exit 1 }' "$PKGS_DB/installed.info"
al@866 408 if [ "$?" -eq 1 ]; then
al@880 409 [ -z "$quiet" ] && (
al@866 410 newline
al@866 411 _ '"%s" package is already installed.' "$(colorize 34 "$1")"
al@866 412 longline "$(_ 'You can use the --forced option to force installation.')"
al@866 413 newline
al@866 414 ) >&2
al@866 415 # Prevent execution 'install' stage:
al@866 416 exit 1
al@866 417 fi
al@866 418 fi
al@864 419 fi
al@864 420
al@844 421 if [ -n "$extra" ]; then
al@844 422 # When '--extra' option given, extra-package has priority over 'regular' packages
al@844 423 get_pkg_extra "$1"
al@844 424 else
al@844 425 # Try to get 'package', then 'get-package', then extra 'package'
al@844 426 get_pkg "$1"
al@844 427 fi